unit MainUnit;

interface

uses
   SysUtils, Windows, Messages, Classes, Controls, Dialogs, StdCtrls, ExtCtrls,
   ComCtrls, Menus, Forms, Grids, MPHexEditor, SynEdit, SynMemo, ELPropInsp,
   ColorGrd, TypInfo, Graphics;

type

   TWinControls = class of TWinControl;
   
   procedure SetHost(var ah :hwnd; i:thandle); stdcall; export;
   procedure Create(cn :PChar; var hParent:hwnd; x,y,cx,cy :integer; var typ :TObject); stdcall; export;
   function DestroyInstances :integer; stdcall; export;
   function GetClasses :PChar;stdcall;export;

   function SetProp(c:hwnd;p,v:PChar):boolean; stdcall;export;
   function GetProp(c:hwnd;p:PChar):PChar; stdcall;export;

var
   Instances :TStrings;

implementation

procedure SetHost(var ah :hwnd;i :thandle); stdcall; export;
begin
    Application.Handle:=ah;
    hInstance:=i;
end;

function GetClasses :PChar;
begin
    result:='TLabel,TButton,TCheckBox,TRadioButton,'+
            'TGroupBox,TEdit,TComboBox,TListBox,TScrollBar,'+
            'TMPHexEditor,TDrawGrid,TStringGrid,TColorGrid,'+
            'TToolBar,TTabControl,TPageControl,TTreeView,TTlistView,'+
            'TCoolBar,TPageScroller,THeaderControl,'+
            'TUpDown,TProgressBar,TAnimate,TTrackBar,TMemo,'+
            'TMonthCalendar,TDateTimePicker,TRichEdit,THotKey,TSynEdit';
end;

procedure Create(cn :PChar;  var hParent:hwnd; x,y,cx,cy :integer;var typ :TObject);
var
   ClassRef :TWinControls;
   Ctrl :TWinControl;
begin
    if cn='' then exit;
    ClassRef:=TWinControls(GetClass(StrPas(cn)));
    if ClassRef<>nil then begin
       try
          Ctrl :=ClassRef.Create(nil);
          if Ctrl<>nil then begin
            try
                if hParent>0 then begin
                   if isWindow(hParent) then
                      try
                         Ctrl.ParentWindow:=hParent
                      except end;
                end else
                   if typ<>nil then
                      try
                         Ctrl.Parent:=TWinControl(typ);
                         Ctrl.ParentWindow:= hParent;
                      except end;
                Instances.AddObject(inttostr(Ctrl.Handle),Ctrl);
                Ctrl.Left:=x;
                Ctrl.Top:=y;
                Ctrl.Width:=cx;
                Ctrl.Height:=cy;
                hParent:=Ctrl.Handle;
                typ:=Ctrl;
             except end;
          end
       except
          ShowMessage('DelphiClasses.dll in Error.');
       end;

    end ;
end;

function DestroyInstances :integer; stdcall; export;
var
   i :integer;
begin
    result:=Instances.Count;
    if Instances.Count=0 then exit;
    for i:=Instances.Count-1 downto 0 do begin
        if Instances.Objects[i]<>nil then
           Instances.Objects[i].Free;
        Instances.Delete(i);
    end;
    result:=Instances.Count
end;


function SetProp(c:hwnd;p,v:PChar):boolean;
var
  Pif:PPropInfo;
  i,Addr:integer;
  o:TObject;
  sp,sv,ss:string;
begin
    result:=false;
    if (c=0) or (p=nil) or (v=nil) then exit;
    i:=Instances.IndexOf(inttostr(c));
    if i>-1 then o:=Instances.Objects[i] else o:=nil;
    sp:=StrPas(p);
    sv:=StrPas(v);
    if pos('.',sp)>0 then begin
       ss:=copy(sp,pos('.',sp)+1,length(sp));
       Pif:=GetPropInfo(o,ss);
       if Pif<>nil then begin
          Addr:=GetPropValue(o,ss);
          if Pif^.PropType^.Name='TStrings' then begin
             TStrings(Addr).Text:=v
          end;
          if Pif^.PropType^.Name='TFont' then begin
          if comparetext('color',ss)=0 then TFont(Addr).Color:=TColor(StrToInt(v));
          if comparetext('name',ss)=0 then TFont(Addr).Name:=v;
          if comparetext('size',ss)=0 then TFont(Addr).Size:=StrToInt(v);
          end;
       end
    end else begin
       Pif:=GetPropInfo(o,sp);
       if Pif<>nil then begin
          if Pif^.PropType^.Name='TColor' then
             SetPropValue(o,sp,TColor(StrToInt(sv)))
          else
             SetPropValue(o,sp,sv);
       end;
    end ;
    result:=true;
end;

function GetProp(c:hwnd;p:PChar):PChar;
var
  Pif:PPropInfo;
  i,Addr:integer;
  o:TObject;
  sp,ss:string;
begin
    result:=nil;
    if (c=0) or (p=nil)  then exit;
    i:=Instances.IndexOf(inttostr(c));
    if i>-1 then o:=Instances.Objects[i] else o:=nil;
    sp:=StrPas(p);
    if pos('.',sp)>0 then begin
       ss:=copy(sp,pos('.',sp)+1,length(sp));
       Pif:=GetPropInfo(o,ss);
       if Pif<>nil then begin
          Addr:=GetPropValue(o,ss);
          if Pif^.PropType^.Name='TStrings' then begin
             result:=PChar(TStrings(Addr).Text)
          end;
          if Pif^.PropType^.Name='TFont' then begin
          if comparetext('color',ss)=0 then result:=PChar(integer(TFont(Addr).Color));
          if comparetext('name',ss)=0 then result:=PChar(TFont(Addr).Name);
          if comparetext('size',ss)=0 then result:=PChar(IntToStr(TFont(Addr).Size));
          end;
       end
    end else begin
       Pif:=GetPropInfo(o,sp);
       if Pif<>nil then begin
          if Pif^.PropType^.Name='TColor' then
             result:=PChar(IntToStr(integer(GetPropValue(o,sp))))
          else
             result:=PChar(String(GetPropValue(o,sp)));
       end;
    end

end;

initialization
   Instances :=TStringList.Create;
   RegisterClasses([TLabel,TButton,TCheckBox,TRadioButton,
                   TGroupBox,TEdit,TComboBox,TListBox,TScrollBar,
                   TMPHexEditor,TDrawGrid,TStringGrid,TColorGrid,
                   TToolBar,TTabControl,TPageControl,TTreeView,TListView,
                   TCoolBar,TPageScroller,THeaderControl,
                   TUpDown,TProgressBar,TAnimate,TTrackBar,TMemo,
                   TMonthCalendar, TDateTimePicker,TRichEdit,THotKey,TSynEdit]);
finalization
   unRegisterClasses([TLabel,TButton,TCheckBox,TRadioButton,
                   TGroupBox,TEdit,TComboBox,TListBox,TScrollBar,
                   TMPHexEditor,TDrawGrid,TStringGrid,TColorGrid,
                   TToolBar,TTabControl,TPageControl,TTreeView,TListView,
                   TCoolBar,TPageScroller,THeaderControl,
                   TUpDown,TProgressBar,TAnimate,TTrackBar,TMemo,
                   TMonthCalendar, TDateTimePicker,TRichEdit,THotKey,TSynEdit]);
   Instances.Free;
end.
